#define TuTTy "Cosmin-Mihai Tutunaru"
#include<cstdio>
#include<cassert>
#include<vector>
#include<set>
#include<map>
#include<algorithm>
#define infile "ksort.in"
#define outfile "ksort.out"
#define nMax 100013

using namespace std;

set <int> forAssert;
map <int, int> hash;
vector <bool> vz;
vector <int> v;
vector <int> w; //v in increasing order
vector <int> good; //position elements in good position
vector <int> bad; //position elements in wrong position
vector <int> pos; //position for each element
vector < pair <int, int> > cycle; //length and position of one element of every cycle
vector < pair <int, int> > sol;
int current;
int n, k;

bool cycleCMP(pair <int, int> a, pair <int, int> b) {
  return (a.first > b.first);
}

void read() {
  scanf("%d %d\n", &n, &k);
  assert(3 <= n && n <= 100*1000);
  assert(0 <= k && k <= n);
  for(int i = 1; i <= n; ++i) {
    int x;
    scanf("%d", &x);
    v.push_back(x);
    if(forAssert.find(x) != forAssert.end())
      assert(true == false);
    forAssert.insert(x);
  }
}

void init() {
  w = v;
  sort(w.begin(), w.end());

  for(unsigned i = 0; i < w.size(); ++i)
    hash[w[i]] = i;

  for(unsigned i = 0; i < v.size(); ++i)
    v[i] = hash[v[i]];

  pos.assign(n, 0);
  for(unsigned i = 0; i < v.size(); ++i)
    pos[v[i]] = i;
}

int getK() {
  int count = 0;
  for(unsigned i = 0; i < v.size(); ++i)
    if(v[i] == (int)i)
      count++;
  return count;
}

int cycleLength(int p) {
  int pp = p;
  int length = 0;

  do {
    ++length;
    vz[p] = true;
    p = pos[p];
  } while(p != pp);

  return length;
}

int getGoodPosition() {
  int x = good.back();
  good.pop_back();
  current--;
  return x;
}

int getBadPosition() {
  int x = bad.back();
  bad.pop_back();
  return x;
}

void move(int p1, int p2) {
  swap(v[p1], v[p2]);
  swap(pos[v[p1]], pos[v[p2]]);
  sol.push_back(make_pair(p1, p2));
}

void add(int count) {
  int p = cycle.back().second; cycle.pop_back();
  while(count--)
    move(p, v[p]);
}

void sub() {
  int p1 = getGoodPosition();
  int p2 = (current > k) ? getGoodPosition() : getBadPosition();
  move(p1, p2);
  bad.push_back(p1);
  bad.push_back(p2);
}

void solve() {
  if(k+1 == n) return;
  current = getK();

  if(current < k) {
    vz.assign(n, false);
    for(unsigned i = 0; i < v.size(); ++i)
      if(v[i] != (int)i && !vz[i])
        cycle.push_back(make_pair(cycleLength(i), i));
    sort(cycle.begin(), cycle.end(), cycleCMP);

    while(current < k) {
      int count =  k - current;
      if(cycle.back().first <= count)
        current += cycle.back().first, add(cycle.back().first - 1);
      else {
        while(cycle.size() > 2) cycle.pop_back();
        if(count == 1) {
          if(cycle.size() > 1) cycle.pop_back();
          if(cycle.back().first == 2) current += 2;
          else current++;
          add(1);
        }
        else if(cycle.size() == 2) {
          current += count - 1, add(count-1);
          current += 1, add(1);
        }
        else {
          if(count + 1 == cycle.back().first)
            current += cycle.back().first, add(cycle.back().first - 1);
          else current += count, add(count);
        }
      }
    }
  }

  if(current > k) {
    for(unsigned i = 0; i < v.size(); ++i)
      if(v[i] == (int)i)
        good.push_back(i);
      else bad.push_back(i);

    while(current > k)
      sub();
  }
}

void write() {
  if(k+1 == n) {
    printf("-1\n");
    return;
  }
  printf("%d\n", sol.size());
  for(unsigned i = 0; i < sol.size(); ++i)
    printf("%d %d\n", sol[i].first + 1, sol[i].second + 1);
}

int main() {
  freopen(infile, "r", stdin);
  freopen(outfile, "w", stdout);

  read();
  init();
  solve();
  write();

  fclose(stdin);
  fclose(stdout);
  return 0;
}
