#define TuTTy "Cosmin-Mihai Tutunaru"
#include<cstdio>
#include<cassert>
#include<vector>
#include<queue>
#include<set>
#include<algorithm>
#define infile "ksort.in"
#define outfile "ksort.out"
#define nMax 100013

using namespace std;

struct move {
  int x, y;
};

set <int> forAssert;
set < vector <int> > hash;
queue < pair < vector <int>, vector <struct move> > > q;
vector <int> v;
vector <int> w; //v in increasing order
vector <struct move> sol;
int n, k;

void read() {
  scanf("%d %d\n", &n, &k);
  assert(3 <= n && n <= 100*1000);
  assert(0 <= k && k <= n);
  for(int i = 1; i <= n; ++i) {
    int x;
    scanf("%d", &x);
    v.push_back(x);
    if(forAssert.find(x) != forAssert.end())
      assert(true == false);
    forAssert.insert(x);
  }
}

void init() {
  w = v;
  sort(w.begin(), w.end());
}

void insert(vector <int> v, vector <struct move> m) {
  q.push(make_pair(v, m));
  hash.insert(v);
}

int ksort(vector <int> v) {
  int count = 0;
  for(unsigned i = 0; i < v.size(); ++i)
    if(v[i] == w[i])
      ++count;
  return count;
}

void solve() {
  if(k+1 == n) return;
  insert(v, sol);
  while(!q.empty()) {
    vector <int> v = q.front().first;
    sol = q.front().second;
    q.pop();

    int moves = ksort(v);
    if(moves == k)
      return;

    for(unsigned i = 0; i < v.size(); ++i)
      for(unsigned j = i+1; j < v.size(); ++j) {
        swap(v[i], v[j]);
        if(hash.find(v) == hash.end()) {
          struct move m; m.x = i, m.y = j;
          sol.push_back(m);
          int newMoves = ksort(v);

          if(newMoves == k)
            return;

          if((moves < k && moves < newMoves) || (moves > k && moves > newMoves))
            insert(v, sol);

          sol.pop_back();
        }
        swap(v[i], v[j]);
      }
  }
}

void write() {
  if(k+1 == n) {
    printf("-1\n");
    return;
  }
  printf("%d\n", sol.size());
  for(unsigned i = 0; i < sol.size(); ++i)
    printf("%d %d\n", sol[i].x + 1, sol[i].y + 1);
}

int main() {
  freopen(infile, "r", stdin);
  freopen(outfile, "w", stdout);

  read();
  init();
  solve();
  write();

  fclose(stdin);
  fclose(stdout);
  return 0;
}
